"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const UserSchema_1 = __importDefault(require("../database/UserSchema"));
const TokenService_1 = __importDefault(require("./TokenService"));
class UserService {
    constructor() {
        this.user = UserSchema_1.default;
    }
    register(name, email, password, idSpotify) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                const user = yield this.user.create({
                    name,
                    email,
                    password,
                    idSpotify
                });
                return TokenService_1.default.createToken(user);
            }
            catch (error) {
                throw new Error(error.message);
            }
        });
    }
    login(email, password) {
        return __awaiter(this, void 0, void 0, function* () {
            const user = yield this.user.findOne({ email });
            if (!user) {
                throw new Error('Wrong credentials given');
            }
            if (yield user.isValidPassword(password)) {
                return TokenService_1.default.createToken(user);
            }
            else {
                throw new Error('Wrong credentials given');
            }
        });
    }
}
exports.default = UserService;
//# sourceMappingURL=UserService.js.map